OGRE: Ogre::DynLibManager Class Reference - OGRE Documentation

Public Member Functions | Static Public Member Functions | Protected Types | Protected Attributes | Static Protected Attributes

# Ogre::DynLibManager Class Reference
[General]

Manager for Dynamic-loading Libraries. More...

`#include <OgreDynLibManager.h>`

Inheritance diagram for Ogre::DynLibManager:
[legend]

List of all members.

## Public Member Functions
| DynLibManager ()
| Default constructor.
virtual | ~DynLibManager ()
| Default destructor.
DynLib * | load (const String &filename)
| Loads the passed library.
void | unload (DynLib *lib)
| Unloads the passed library.
void * | operator new (size_t sz, const char *file, int line, const char *func)
| operator new, with debug line info
void * | operator new (size_t sz)
void * | operator new (size_t sz, void *ptr)
| placement operator new
void * | operator new[] (size_t sz, const char *file, int line, const char *func)
| array operator new, with debug line info
void * | operator new[] (size_t sz)
void | operator delete (void *ptr)
void | operator delete (void *ptr, void *)
void | operator delete (void *ptr, const char *, int, const char *)
void | operator delete[] (void *ptr)
void | operator delete[] (void *ptr, const char *, int, const char *)
## Static Public Member Functions
static DynLibManager & | getSingleton (void)
| Override standard Singleton retrieval.
static DynLibManager * | getSingletonPtr (void)
| Override standard Singleton retrieval.
static DynLibManager & | getSingleton (void)
static DynLibManager * | getSingletonPtr (void)
## Protected Types
typedef map< String, DynLib * > ::type | DynLibList
## Protected Attributes
DynLibList | mLibList
## Static Protected Attributes
static DynLibManager * | ms_Singleton

## Detailed Description

Manager for Dynamic-loading Libraries.

Remarks:
  This manager keeps a track of all the open dynamic-loading libraries, opens them and returns references to already-open libraries.

Definition at line 47 of file OgreDynLibManager.h.

## Member Typedef Documentation

typedef map<String, DynLib*>::type Ogre::DynLibManager::DynLibList`[protected]`

Definition at line 50 of file OgreDynLibManager.h.

## Constructor & Destructor Documentation

Ogre::DynLibManager::DynLibManager | ( |  | ) |

Default constructor.

Note:
  Should never be called as the singleton is automatically created during the creation of the Root object.

See also:
  Root::Root

virtual Ogre::DynLibManager::~DynLibManager | ( |  | ) | `[virtual]`

Default destructor.

See also:
  Root::~Root

## Member Function Documentation

static DynLibManager& Ogre::DynLibManager::getSingleton | ( | void |  | ) | `[static]`

Override standard Singleton retrieval.

Remarks:
  Why do we do this? Well, it's because the Singleton implementation is in a .h file, which means it gets compiled into anybody who includes it. This is needed for the Singleton template to work, but we actually only want it compiled into the implementation of the class based on the Singleton, not all of them. If we don't change this, we get link errors when trying to use the Singleton-based class from an outside dll.

  This method just delegates to the template version anyway, but the implementation stays in this single compilation unit, preventing link errors.

static DynLibManager & Ogre::Singleton< DynLibManager >::getSingleton | ( | void |  | ) | `[static, inherited]`

Definition at line 90 of file OgreSingleton.h.

static DynLibManager* Ogre::DynLibManager::getSingletonPtr | ( | void |  | ) | `[static]`

Override standard Singleton retrieval.

Remarks:
  Why do we do this? Well, it's because the Singleton implementation is in a .h file, which means it gets compiled into anybody who includes it. This is needed for the Singleton template to work, but we actually only want it compiled into the implementation of the class based on the Singleton, not all of them. If we don't change this, we get link errors when trying to use the Singleton-based class from an outside dll.

  This method just delegates to the template version anyway, but the implementation stays in this single compilation unit, preventing link errors.

static DynLibManager * Ogre::Singleton< DynLibManager >::getSingletonPtr | ( | void |  | ) | `[static, inherited]`

Definition at line 92 of file OgreSingleton.h.

DynLib* Ogre::DynLibManager::load | ( | const String & | filename | ) |

Loads the passed library.

Parameters:

  | filename | The name of the library. The extension can be omitted

template<class Alloc >

void Ogre::AllocatedObject< Alloc >::operator delete | ( | void * | ptr,
|  | void * |  |
| ) |  |  | `[inherited]`

Definition at line 101 of file OgreMemoryAllocatedObject.h.

template<class Alloc >

void Ogre::AllocatedObject< Alloc >::operator delete | ( | void * | ptr | ) | `[inherited]`

Definition at line 95 of file OgreMemoryAllocatedObject.h.

template<class Alloc >

void Ogre::AllocatedObject< Alloc >::operator delete | ( | void * | ptr,
|  | const char * | ,
|  | int | ,
|  | const char * |  |
| ) |  |  | `[inherited]`

Definition at line 107 of file OgreMemoryAllocatedObject.h.

template<class Alloc >

void Ogre::AllocatedObject< Alloc >::operator delete[] | ( | void * | ptr | ) | `[inherited]`

Definition at line 112 of file OgreMemoryAllocatedObject.h.

template<class Alloc >

void Ogre::AllocatedObject< Alloc >::operator delete[] | ( | void * | ptr,
|  | const char * | ,
|  | int | ,
|  | const char * |  |
| ) |  |  | `[inherited]`

Definition at line 118 of file OgreMemoryAllocatedObject.h.

template<class Alloc >

void* Ogre::AllocatedObject< Alloc >::operator new | ( | size_t | sz | ) | `[inherited]`

Definition at line 72 of file OgreMemoryAllocatedObject.h.

template<class Alloc >

void* Ogre::AllocatedObject< Alloc >::operator new | ( | size_t | sz,
|  | void * | ptr |
| ) |  |  | `[inherited]`

placement operator new

Definition at line 78 of file OgreMemoryAllocatedObject.h.

template<class Alloc >

void* Ogre::AllocatedObject< Alloc >::operator new | ( | size_t | sz,
|  | const char * | file,
|  | int | line,
|  | const char * | func |
| ) |  |  | `[inherited]`

operator new, with debug line info

Definition at line 67 of file OgreMemoryAllocatedObject.h.

template<class Alloc >

void* Ogre::AllocatedObject< Alloc >::operator new[] | ( | size_t | sz | ) | `[inherited]`

Definition at line 90 of file OgreMemoryAllocatedObject.h.

template<class Alloc >

void* Ogre::AllocatedObject< Alloc >::operator new[] | ( | size_t | sz,
|  | const char * | file,
|  | int | line,
|  | const char * | func |
| ) |  |  | `[inherited]`

array operator new, with debug line info

Definition at line 85 of file OgreMemoryAllocatedObject.h.

void Ogre::DynLibManager::unload | ( | DynLib * | lib | ) |

Unloads the passed library.

Parameters:

  | filename | The name of the library. The extension can be omitted

## Member Data Documentation

DynLibList Ogre::DynLibManager::mLibList`[protected]`

Definition at line 51 of file OgreDynLibManager.h.

DynLibManager * Ogre::Singleton< DynLibManager >::ms_Singleton`[static, protected, inherited]`

Definition at line 75 of file OgreSingleton.h.

The documentation for this class was generated from the following file:

- OgreDynLibManager.h

Copyright © 2008 Torus Knot Software Ltd
This work is licensed under a Creative Commons Attribution-ShareAlike 3.0 Unported License.
Last modified Wed Nov 3 2010 19:24:54